//Charly DUMUR
//Nicolas BOUTIN
//Le 31/01/07

//************ Fichier d'Entete ***************/

#include "I2Clib.h"

//************ Variables Fonctions ************//

static unsigned char cusec=0;		//Variable pour les units de secondes
static unsigned char cdsec=0;		//Variable pour les dizaines de secondes
static unsigned char ccentainesec=0;//Variable pour les centaines de secondes

//Static car conserve la valeur du chrono mme aprs son arrt et relancement  cette valeur.

//************* Prototypes Fonctions ********************//

void Chrono (void);
void ResetChrono(void);
void ChronoBIR(void);

//************ Fonctions  ************//

void ChronoBIR (void)
{	
	unsigned char tempcdixisec=0;   	//Variable temporaire d'acquisition des diximes de secondes
	cdixisec=0; 				    	// Mise  zro des diximes de secondes

	LCDGotoXY(0,0); 					// Curseur en (0;0)
	LCDPutText("CHRONOMETRE");			// Affichage du nom du menu					
	LCDGotoXY(1,2);						// Curseur en (1;2)
	LCDPutText("Declenchement B.I.R.");	// Affichage du mode de dclenchement du chronomtre
	
	while(J1D==1); 						// Attente franchissement barrire
	Delay10KTCYx(10);					//Dlai pour ne pas detecter deux fois  la suite un passage devant la BIR

	while(J1A==1)						// Tant que le robot n'est pas arriv(2me franchissement BIR)...
	{
		if(cdixisec==10)				
		{	cusec++;					// Incrmentation des units de secondes
			cdixisec=0;					// RAZ des diximes de secondes
		}
		if (cusec==10)
		{	cdsec++;					// Incrmentation des dizaines de secondes
			cusec=0;					// RAZ des units de secondes
		}
		if(cdsec==10)
		{	ccentainesec++;				// Incrmentation des centaines de secondes
			cdsec=0;					// RAZ des dizaines de secondes
		}
		if (ccentainesec==10)
		{	
			ccentainesec=0;				// RAZ des centaines de secondes
		}
		RCONbits.IPEN=0;				// Interdiction des interruptions
		tempcdixisec=cdixisec;			// Mise  jour des diximes de secondes
		RCONbits.IPEN=1;				// Autorisation des interruptions

		SendI2C(0x4E,Af[ccentainesec]);	//Aff1
		SendI2C(0x4A,Af[cdsec]);		//Aff2
		SendI2C(0x46,Af[cusec]);		//Aff3
		SendI2C(0x4C,Af[cdixisec]);		//Aff4	

	}
				
	LCDGotoXY(1,1);
	LCDPutInt(ccentainesec);			// Affichage des centaines de secondes en (1;1)	
	LCDGotoXY(2,1);
	LCDPutInt(cdsec);					// Affichage des dizaines de secondes en (2;1)
	LCDGotoXY(3,1);
	LCDPutInt(cusec);					// Affichage des units de secondes en (3;1)
	LCDGotoXY(4,1);
	LCDPutText("s");					// Affichage du symble seconde en (4;1)
	LCDGotoXY(5,1);
	LCDPutInt(cdixisec);				// Affichage des diximes de secondes en (5;1)
	LCDGotoXY(6,1);
	LCDPutInt(ccentisec);				// Affichage des centimes de secondes en (6;1)
	LCDGotoXY(7,1);
	LCDPutChar('0');					// Affichage du zro pour la conversion des centimes de secondes en millisecondes
	LCDGotoXY(8,1);
	LCDPutText("ms");					// Affichage du symble milliseconde en (4;1)
	
	Delay10KTCYx(500);					// Pause pour affichage
	while(JoyX()!=-1);					// Attente d'un retour en arrire pour afficher le rsultat sur le LCD
		
}	


void ResetChrono(void)
{
	ccentisec=0;					 										
	cdixisec=0;
									// RAZ des variables temporelles
	cusec=0;
	cdsec=0;
	ccentainesec=0;

	SendI2C(0x4E,Af[ccentainesec]);	// Envoi sur Aff1
	SendI2C(0x4A,Af[cdsec]);		// Envoi sur Aff2
	SendI2C(0x46,Af[cusec]);		// Envoi sur Aff3
	SendI2C(0x4C,Af[cdixisec]);		// Envoi sur Aff4

	LCDGotoXY(0,0);
	LCDPutText("CHRONOMETRE");
	LCDGotoXY(1,2);
	LCDPutText("Reset effectue");	// Affichage sur le LCD		
	LCDGotoXY(1,3);
	LCDPutText("Gauche = Retour");
}

void Chrono (void)
{
	cdixisec=0;

	LCDGotoXY(0,0);
	LCDPutText("CHRONOMETRE");		// Affichage sur le LCD
	LCDGotoXY(1,3);
	LCDPutText("Retour = Stop");

	while((JoyX()!=-1))				//Tant que pas de demande de retour par le joystick 
	{
		if(cdixisec==10)			//
		{	cusec++;				//
			cdixisec=0;				//
		}							//	
		if (cusec==10)				//	
		{	cdsec++;				//	
			cusec=0;				// Incrmentation des variables
		}							//
		if(cdsec==10)				//	
		{	ccentainesec++;			//
			cdsec=0;				//
		}							//
		if (ccentainesec==10)		//
		{							//
			ccentainesec=0;			//
		}
		SendI2C(0x4E,Af[ccentainesec]);	// Envoi sur Aff1
		SendI2C(0x4A,Af[cdsec]);		// Envoi sur Aff2
		SendI2C(0x46,Af[cusec]);		// Envoi sur Aff3
		SendI2C(0x4C,Af[cdixisec]);		// Envoi sur Aff4	

	}
		LCDGotoXY(1,1);
		LCDPutInt(ccentainesec);	
		LCDGotoXY(2,1);
		LCDPutInt(cdsec);
		LCDGotoXY(3,1);
		LCDPutInt(cusec);
		LCDGotoXY(4,1);
		LCDPutText("s");
		LCDGotoXY(5,1);					// Affichage sur le LCD
		LCDPutInt(cdixisec);
		LCDGotoXY(6,1);
		LCDPutInt(ccentisec);
		LCDGotoXY(7,1);
		LCDPutChar('0');
		LCDGotoXY(8,1);
		LCDPutText("ms");
		
		Delay10KTCYx(500);				// Pause pour affichage
		while(JoyX()!=-1);				// Bloquant pour afficher le resultat sur le LCD
		
}	
