//Charly DUMUR
//Nicolas BOUTIN
//Le 31/01/07

//************ Prototypes Fonctions ************//

void InterruptVectorH(void);
void InterruptServiceRoutineH();

void InterruptVectorL(void);
void InterruptServiceRoutineL();

void InitInterrupt(void);

//************ Fonctions  ************//

void InitInterrupt(void)
{
	OpenTimer0( TIMER_INT_ON &	//Interrupt enabled
				T0_16BIT &		//16 bit mode
				T0_SOURCE_INT &	//Internal clock source
				T0_PS_1_16);	//division par 16

	WriteTimer0(62411);			//Chargement du compteur a 2^16-3125(10ms)=62411

	INTCONbits.TMR0IF = 0;		//RAZ Flag Timer0
 	INTCON3bits.INT1IF=0;		//RAZ flag interruption externe(DCF)

	INTCON2bits.INTEDG1=1;		//Dtection front montant (INT1)(DCF)

	INTCON2bits.TMR0IP=1;		//Haute priorit (Timer0)
	INTCON3bits.INT1IP=0;		//Basse priorit (INT1)(DCF)
	
	RCONbits.IPEN=1;			//Autorisation des priorits d'interruptions
	
	INTCONbits.GIE=1;			//Autorisation interruptions gnrales (haute priorit)
	INTCONbits.PEIE=1;			//Autorise interruption des phriphriques de basse priorit

	INTCONbits.TMR0IE=1;		//Autorise interruption TMR0 (Timer0)
	INTCON3bits.INT1IE=1;		//Autorise interruption externe INT1(DCF)
}

//Vecteur d'interruption haute --------------------------------------------------------------------
#pragma code InterruptVectorH = 0x08
void InterruptVectorH(void)
{
	_asm
		goto InterruptServiceRoutineH	//Saut vers la routine d'interrutpion Haute
	_endasm
}

#pragma code
#pragma interrupt InterruptServiceRoutineH
//Routine interruption de priorit haute
void InterruptServiceRoutineH()
{
	if(INTCONbits.TMR0IF)		// Si interruption du timer 0 ...
	{	
	
		centisec++;				// Incrmenter les centimes de secondes de l'horloge
		ccentisec++;			// Incrmenter les centimes de secondes du chronomtre
		
		if(CptDCF==15)	
		{
			CptDCF=0;
		}
		else CptDCF++;	         //Compter 150ms pour la dtection du niveau logique des bits DCF

		if(!INTCON3bits.INT1IF)  // Si pas de front montant sur la trame DCF	
		{
			if(DebDCF==99)
			{
				DebDCF=0;
			}
			else DebDCF++;  	//Compte 990ms pour la dtection du dbut de trame DCF
		}
		else DebDCF=0;

		if (centisec==10) 
		{	dixisec++;			// Incrmentation des diximes de secondes pour l'horloge
			cdixisec++; 		// Incrmentation des diximes de secondes pour le chrono
			centisec=0;
			ccentisec=0;
		}
		if (dixisec==10)
		{	usec++;				// Incrmentation des units de secondes		
			dixisec=0;
		}
		if (usec==10)
		{	dsec++;				// Incrmentation des dizaines de secondes
			usec=0;
		}
		if (dsec==6)
		{	umin++;				// Incrmentation des units de minutes
			dsec=0;		
		}	
		if(umin==10)
		{	dmin++;				// Incrmentation des dizaines de minutes
			umin=0;
		}
		if(dmin==6)
		{	uheure++;			// Incrmentation des units d'heures
			dmin=0;
		}
		if(uheure==10)
		{	dheure++;			// Incrmentation des dizaines d'heures
			uheure=0;
		}
		if((dheure==2) && (uheure==4))  // Si l'heure est gale  24 heures	
		{	dheure=0;					// RAZ des units d'heures
			uheure=0;					// RAZ des dizaines d'heures
		}
		INTCONbits.TMR0IF=0;			//Acquittement interruption TMR0
		WriteTimer0(62411);				//Rechargement Timer0
	}
	//Fin interruption Timer0

} 	
#pragma code

//Vecteur d'interruption basse---------------------------------------------------------------------
#pragma code InterruptVectorL = 0x18
void InterruptVectorL(void)
{
	_asm
		goto InterruptServiceRoutineL	//Saut vers la routine d'interruption Basse
	_endasm
}

#pragma code
#pragma interrupt InterruptServiceRoutineL
//Routine interruption de priorit basse
void InterruptServiceRoutineL()
{
	if(INTCON3bits.INT1IF)
	{
		//SW1=!SW1;				   	// Complmenter LED1 :utilis pour le debogage
		DCFNL=DetectNL();		
		SW2=DCFNL;			        // Visualisation du niveau logique du signal DCF sur la LED2		
		TabDCF[CptTabDCF]=DCFNL;	// Stockage du niveau logique du bit de la trame DCF dans le tableau
			
		if(CptTabDCF==60)	
			CptTabDCF=0;
		else	
			CptTabDCF++;			// Incrmentation de l'indice du tableau DCF

		DebDCF=0;					// RAZ de la variable servant  dtecter le dbut de trame DCF 
		INTCON3bits.INT1IF=0;		//Acquittement de INT1
	}
	//Fin interruption front montant sur INT1 (dcf)
}

#pragma code

