/* Programme de dmonstration de la liaison srie
 
	Fichier 		: I2Clib.h

	Compilateur 	: MPLAB C18
	date 			: 14/02/2006
 	Auteur			: Philippe Lucidarme (philippe.lucidarme@univ-angers.fr)
	Cible 			: PIC18F452 
   	Carte			: CNC Micro
	Quartz			: 20 MHz
 	
	Rsum			: Bibliothque permettant l'utilisation du module MSSP en mode ic 
	
	Description		: 

*/

#ifndef __I2CLIB__
#define __I2CLIB__

//*********************** Prototypes des fonctions ************************/

void InitI2C (void);		// Initialise le module IC
unsigned char 	SendI2C (unsigned char Adresse, unsigned Data);		// Envoie une donne sur l'ic

//************************** Code des fonctions ***************************/

// Initialise le module I2C 
void InitI2C(void)
{
	SSPCON1=0x28;		// Enable port + Master mode, clock=Fosc/(4*(SSPADD+1))
	SSPSTAT=0x80;		// Slew rate disabled
	SSPADD=250;			// Vitesse de l'horloge (100KHz) 
						// 20000000/(4*(49+1))=100KHz
}

// Envoie une donne Data  l'adresse ic Adresse
// La fonction retourne 0 si tout s'est bien pass
// La fonction retourne 1 sans acknoledgement
unsigned char 	SendI2C (unsigned char Adresse, unsigned Data)
{
	// Bit de start	
	SSPCON2bits.SEN=1;			// Envoie le bit de start
	while (SSPCON2bits.SEN);	// Attends la fin de l'envoie

	// Transmission de l'adresse
	SSPBUF=Adresse & 0xFE;		// Envoie l'adresse en forant le dernier bit  0
	while (SSPSTATbits.R_W);	// Attends la fin de l'envoie
	
	// Acknoledgement
	if (SSPCON2bits.ACKSTAT) 	// Pas d'acknoledgement, on renvoie 1
		return (1); 

	// Transmission de la donne
	SSPBUF=Data;				// Envoie la donne
	while (SSPSTATbits.R_W);	// Attends la fin de l'envoie
	
	// Acknoledgement
	if (SSPCON2bits.ACKSTAT) 	// Pas d'acknoledgement, on renvoie 1
		return (1); 
	
	// Bit de stop
	SSPCON2bits.PEN=1;			// Envoie le bit de stop
	while (SSPCON2bits.PEN);	// Attends la fin de l'envoie
	
	return (0);					// Tout s'est bien pass 	
}

#endif
