/**********Librairies Convertisseur et Joystick  *************/

#include <adc.h>
#include <math.h> //utilis pour la fonction fabs() 

int JoyZeroX, JoyZeroY;
// variables globales correspondant  la 
// position du joystick lors de l'initialisation du programme

void InitJoystick(void);
void ZeroJoystick(void);
int  JoyX(void);
int  JoyY(void);

/*
InitJoystick 
Fonction qui initialise le joystick (Convertisseur A/N) et calibre les zros
*/
void InitJoystick(void)
{		
	// Initialisation et configuration du convertisseur
	OpenADC(	ADC_FOSC_2 &		// Horloge interne / 2
 				ADC_RIGHT_JUST  & 	// Resultat ds bit poids faible
				ADC_3ANA_0REF, 		// AN0, AN1, AN3 analogique les autre numriques
				ADC_CH1 &			// Slectionne le canal 1
 				ADC_INT_OFF);		// Pas d'interruptions

	// Calibre les zros du joystick
	ZeroJoystick();
}

/*
ZeroJoystick 
Fonction qui calibre les zros selon les deux axes
*/
void ZeroJoystick(void)
{
	// Axe des X
	SetChanADC(ADC_CH0);	// Slectionne le canal
	ConvertADC();			// Effectue la conversion
	while( BusyADC()!=0);	// Attend la fin de la conversion
	JoyZeroX=ReadADC();		// Mmorise le zro	

	// Axe des Y
	SetChanADC(ADC_CH1);	// Slectionne le canal
	ConvertADC();			// Effectue la conversion
	while( BusyADC()!=0);	// Attend la fin de la conversion
	JoyZeroY=ReadADC();		// Mmorise le zro	
}

/*
JoyX 
Renvoie la valeur en X du joystick
*/

int JoyY(void)
{
	int Val;
	// Axe des X
	SetChanADC(ADC_CH0);		// Slectionne le canal
	Delay10TCYx(5);				// Permet de changer de canal correctement  
	ConvertADC();				// Effectue la conversion
	while( BusyADC()!=0);		// Attend la fin de la conversion
	Val=ReadADC()-JoyZeroY; 	// Mmorise la valeur lue compare  la valeur initiale
	if ( ( (Val)<200 ) && ( (Val)>(-300)))		// Marge de valeur position
		return 0;				//Renvoie 0 si le joystick ne bouge pas
	if ((Val)<=-300)			
		return (-1);			// Renvoie -1 si le joystick bouge vers la gauche
	else return 1;				// Renvoie 1 si le joystick bouge vers la droite
}
/*
JoyY 
Renvoie la valeur en Y du joystick
*/

int JoyX(void)
{
	int Val;
	// Axe des X
	SetChanADC(ADC_CH1);		// Slectionne le canal
	Delay10TCYx(5);				//Permet de changer de canal correctement
	ConvertADC();				// Effectue la conversion
	while( BusyADC()!=0);		// Attend la fin de la conversion
	Val=ReadADC()-JoyZeroX; 	//Mmorise la valeur lue compare  la valeur initiale
	if ( ( (Val)<200 ) && ( (Val)>(-400)))			
		return  0;				//Renvoie 0 si le joystick ne bouge pas
	if ((Val)<=-400)	
		return ( 1);			//Renvoie 1 si le joystick bouge vers le haut
	else return -1;				//Renvoie -1 si le joystick bouge vers le bas
}
